Attribute VB_Name = "SID_Basic"
Option Explicit

Global Const LEDOFF = vbBlack
Global Const LEDON = &HFF00&
Global LFO1_Value As Boolean

Global IGNORE As Boolean
Global AktuellerPreset As Long
Global PP As String

Global SID_Register(31) As Byte
Global SID_Register_OLD(31) As Byte

Global AktuellerSEQName As String
Global AktuellerSEQStep As Long
Global LetzterSEQStep As Long
Global SEQ_Register(16, 63) As Byte

Global TZeit1 As Byte
Global TZeit2 As Byte
Global TZeit3 As Byte

Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)


'Declare Inp and Out for port I/O
Public Declare Function Inp Lib "inpout32.dll" _
Alias "Inp32" (ByVal PortAddress As Integer) As Integer
Public Declare Sub Out Lib "inpout32.dll" _
Alias "Out32" (ByVal PortAddress As Integer, ByVal Value As Integer)

'Data-Register (Ausgang)
Global Const LPT1_BASE = &H378
Global Const LPT2_BASE = &H278
Global Const LPT3_BASE = &H3BC

Global Const LPT1_OUTPUT = LPT1_BASE
Global Const LPT2_OUTPUT = LPT2_BASE
Global Const LPT3_OUTPUT = LPT3_BASE

'Control-Register (Datenrichtungsregister)
Global Const LPT1_CONTROL = LPT1_BASE + 2
Global Const LPT2_CONTROL = LPT2_BASE + 2
Global Const LPT3_CONTROL = LPT3_BASE + 2

'Input-Register (Eingang)
Global Const LPT1_INPUT = LPT1_BASE + 1
Global Const LPT2_INPUT = LPT2_BASE + 1
Global Const LPT3_INPUT = LPT3_BASE + 1

Global AKTUELLER_PORT As Long 'zu benutzender LPT-Port
Global DatenRegister As Long
Global DescherRegister As Long


Sub ClearSID()

Dim t As Long

For t = 0 To 31
SID_Register(t) = 0
SID_Register_OLD(t) = 0
Next t
'WriteSIDRegisters (True)

End Sub

Sub Ermittle_Vorhandene_LPT_Ports()

Dim a As String

'3. Parallelport
a = TestePorts(LPT3_BASE)
Main.cLPT3.Enabled = False
Main.cLPT3.Value = False
Main.cLPT3.Caption = "LPT3:"
If a <> "" Then
   Main.cLPT3.Enabled = True
   Main.cLPT3.Caption = "LPT3: " + a
   Main.cLPT3.Value = True
   AKTUELLER_PORT = LPT3_BASE
End If


'2. Parallelport
a = TestePorts(LPT2_BASE)
Main.cLPT2.Enabled = False
Main.cLPT2.Value = False
Main.cLPT2.Caption = "LPT2:"
If a <> "" Then
   Main.cLPT2.Enabled = True
   Main.cLPT2.Caption = "LPT2: " + a
   Main.cLPT2.Value = True
   AKTUELLER_PORT = LPT2_BASE
End If


'1. Parallelport
a = TestePorts(LPT1_BASE)
Main.cLPT1.Enabled = False
Main.cLPT1.Value = False
Main.cLPT1.Caption = "LPT1:"
If a <> "" Then
   Main.cLPT1.Enabled = True
   Main.cLPT1.Caption = "LPT1: " + a
   Main.cLPT1.Value = True
   AKTUELLER_PORT = LPT1_BASE
End If


End Sub

Sub Initialisierung()

Dim t As Long


'RESET-Signal setzen, WRITE aus
DescherRegister = 8
SetzeDescherRegister
Sleep (100)
DescherRegister = 0
SetzeDescherRegister
Sleep (400) '400 ms Reset-Impuls


Call Write_8255_SID(3, 128)
ResetSID

End Sub

Sub Preset_Get()

Dim Lo As Byte
Dim Hi As Byte


'Register 0 + 1: Frequenz VCO1
SID_Register(1) = Int(Main.VCO1_F.Value) / 256
SID_Register(0) = Main.VCO1_F.Value And 255

'Register 2 + 3: PWM VCO1
SID_Register(3) = Int(Main.VCO1_PWM.Value) / 256
SID_Register(2) = Main.VCO1_PWM.Value And 255

'Register 4: Control Register VCO1
SID_Register(4) = 0
If Main.VCO1_Sync.Value = 1 Then SID_Register(4) = SID_Register(4) Or 2
If Main.VCO1_Ring.Value = 1 Then SID_Register(4) = SID_Register(4) Or 4
If Main.VCO1_cTri.Value = 1 Then SID_Register(4) = SID_Register(4) Or 16
If Main.VCO1_cSaw.Value = 1 Then SID_Register(4) = SID_Register(4) Or 32
If Main.VCO1_cSQR.Value = 1 Then SID_Register(4) = SID_Register(4) Or 64
If Main.VCO1_cNoise.Value = 1 Then SID_Register(4) = SID_Register(4) Or 128

'Register 5: D/A VCO1
SID_Register(5) = (15 - Main.VCO1_A.Value) * 16 + (15 - Main.VCO1_D.Value)

'Register 6: R/S VCO1
SID_Register(6) = (15 - Main.VCO1_S.Value) * 16 + (15 - Main.VCO1_R.Value)

'Register 7 + 8: Frequenz VCO2
SID_Register(8) = Int(Main.VCO2_F.Value) / 256
SID_Register(7) = Main.VCO2_F.Value And 255

'Register 9 + 10: PWM VCO2
SID_Register(10) = Int(Main.VCO2_PWM.Value) / 256
SID_Register(9) = Main.VCO2_PWM.Value And 255

'Register 11: Control Register VCO2
SID_Register(11) = 0
If Main.VCO2_Sync.Value = 1 Then SID_Register(11) = SID_Register(11) Or 2
If Main.VCO2_Ring.Value = 1 Then SID_Register(11) = SID_Register(11) Or 4
If Main.VCO2_cTri.Value = 1 Then SID_Register(11) = SID_Register(11) Or 16
If Main.VCo2_cSaw.Value = 1 Then SID_Register(11) = SID_Register(11) Or 32
If Main.VCo2_cSQR.Value = 1 Then SID_Register(11) = SID_Register(11) Or 64
If Main.VCO2_cNoise.Value = 1 Then SID_Register(11) = SID_Register(11) Or 128

'Register 12: D/A VCO2
SID_Register(12) = (15 - Main.VCO2_A.Value) * 16 + (15 - Main.VCO2_D.Value)

'Register 13: R/S VCO2
SID_Register(13) = (15 - Main.VCO2_S.Value) * 16 + (15 - Main.VCO2_R.Value)

'Register 14 + 15: Frequenz VCO3
SID_Register(15) = Int(Main.VCO3_F.Value) / 256
SID_Register(14) = Main.VCO3_F.Value And 255

'Register 16 + 17: PWM VCO3
SID_Register(17) = Int(Main.VCO3_PWM.Value) / 256
SID_Register(16) = Main.VCO3_PWM.Value And 255

'Register 18: Control Register VCO3
SID_Register(18) = 0
If Main.VCO3_Sync.Value = 1 Then SID_Register(18) = SID_Register(18) Or 2
If Main.VCO3_Ring.Value = 1 Then SID_Register(18) = SID_Register(18) Or 4
If Main.VCO3_cTri.Value = 1 Then SID_Register(18) = SID_Register(18) Or 16
If Main.VCO3_cSaw.Value = 1 Then SID_Register(18) = SID_Register(18) Or 32
If Main.VCO3_cSQR.Value = 1 Then SID_Register(18) = SID_Register(18) Or 64
If Main.VCO3_cNoise.Value = 1 Then SID_Register(18) = SID_Register(18) Or 128

'Register 19: D/A VCO3
SID_Register(19) = (15 - Main.VCO3_A.Value) * 16 + (15 - Main.VCO3_D.Value)

'Register 20: R/S VCO3
SID_Register(20) = (15 - Main.VCO3_S.Value) * 16 + (15 - Main.VCO3_R.Value)

'Register 21 + 22: Filter Cutoff - Frequenz
SID_Register(21) = Main.Filter_Cutoff.Value And 7
SID_Register(22) = Int(Main.Filter_Cutoff.Value / 8)

'Register 23: Qszillatoren und Resonanz
SID_Register(23) = Main.Filter_Resonanz.Value * 16
If Main.Filter_VCO1.Value = 1 Then SID_Register(23) = SID_Register(23) Or 1
If Main.Filter_VCO2.Value = 1 Then SID_Register(23) = SID_Register(23) Or 2
If Main.Filter_VCO3.Value = 1 Then SID_Register(23) = SID_Register(23) Or 4
If Main.Filter_EXT.Value = 1 Then SID_Register(23) = SID_Register(23) Or 8

'Register 24: Lautstrke und Filterarten
SID_Register(24) = Main.sVolume.Value
If Main.Filter_LP.Value = 1 Then SID_Register(24) = SID_Register(24) Or 16
If Main.Filter_HP.Value = 1 Then SID_Register(24) = SID_Register(24) Or 32
If Main.Filter_BP.Value = 1 Then SID_Register(24) = SID_Register(24) Or 64
If Main.Filter_Off.Value = 1 Then SID_Register(24) = SID_Register(24) Or 128


IGNORE = False

End Sub

Sub Preset_Put()

IGNORE = True

'Register 0 + 1: Frequenz VCO1
Main.VCO1_F.Value = SID_Register(0) + 256 * SID_Register(1)

'Register 2 + 3: PWM VCO1
Main.VCO1_PWM.Value = SID_Register(2) + 256 * SID_Register(3)

'Register 4: Control Register VCO1
Main.VCO1_Sync.Value = 0: If SID_Register(4) And 2 Then Main.VCO1_Sync.Value = 1
Main.VCO1_Ring.Value = 0: If SID_Register(4) And 4 Then Main.VCO1_Ring.Value = 1
Main.VCO1_cTri.Value = 0: If SID_Register(4) And 16 Then Main.VCO1_cTri.Value = 1
Main.VCO1_cSaw.Value = 0: If SID_Register(4) And 32 Then Main.VCO1_cSaw.Value = 1
Main.VCO1_cSQR.Value = 0: If SID_Register(4) And 64 Then Main.VCO1_cSQR.Value = 1
Main.VCO1_cNoise.Value = 0: If SID_Register(4) And 128 Then Main.VCO1_cNoise.Value = 1

'Register 5: D/A VCO1
Main.VCO1_D.Value = (15 - SID_Register(5)) And 15
Main.VCO1_A.Value = 15 - Int(SID_Register(5) / 16)

'Register 6: S/R VCO1
Main.VCO1_S.Value = 15 - Int(SID_Register(6) / 16)
Main.VCO1_R.Value = (15 - SID_Register(6)) And 15

'Register 7 + 8: Frequenz VCO2
Main.VCO2_F.Value = SID_Register(7) + 256 * SID_Register(8)

'Register 9 + 10: PWM VCO2
Main.VCO2_PWM.Value = SID_Register(9) + 256 * SID_Register(10)

'Register 11: Control Register VCO2
Main.VCO2_Sync.Value = 0: If SID_Register(11) And 2 Then Main.VCO2_Sync.Value = 1
Main.VCO2_Ring.Value = 0: If SID_Register(11) And 4 Then Main.VCO2_Ring.Value = 1
Main.VCO2_cTri.Value = 0: If SID_Register(11) And 16 Then Main.VCO2_cTri.Value = 1
Main.VCo2_cSaw.Value = 0: If SID_Register(11) And 32 Then Main.VCo2_cSaw.Value = 1
Main.VCo2_cSQR.Value = 0: If SID_Register(11) And 64 Then Main.VCo2_cSQR.Value = 1
Main.VCO2_cNoise.Value = 0: If SID_Register(11) And 128 Then Main.VCO2_cNoise.Value = 1

'Register 12: D/A VCO2
Main.VCO2_D.Value = (15 - SID_Register(12)) And 15
Main.VCO2_A.Value = 15 - Int(SID_Register(12) / 16)

'Register 13: S/R VCO2
Main.VCO2_S.Value = 15 - Int(SID_Register(13) / 16)
Main.VCO2_R.Value = (15 - SID_Register(13)) And 15

'Register 14+ 15: Frequenz VCO3
Main.VCO3_F.Value = SID_Register(14) + 256 * SID_Register(15)

'Register 16 + 17: PWM VCO3
Main.VCO3_PWM.Value = SID_Register(16) + 256 * SID_Register(17)

'Register 18: Control Register VCO3
Main.VCO3_Sync.Value = 0: If SID_Register(18) And 2 Then Main.VCO3_Sync.Value = 1
Main.VCO3_Ring.Value = 0: If SID_Register(18) And 4 Then Main.VCO3_Ring.Value = 1
Main.VCO3_cTri.Value = 0: If SID_Register(18) And 16 Then Main.VCO3_cTri.Value = 1
Main.VCO3_cSaw.Value = 0: If SID_Register(18) And 32 Then Main.VCO3_cSaw.Value = 1
Main.VCO3_cSQR.Value = 0: If SID_Register(18) And 64 Then Main.VCO3_cSQR.Value = 1
Main.VCO3_cNoise.Value = 0: If SID_Register(18) And 128 Then Main.VCO3_cNoise.Value = 1

'Register 19: D/A VCO3
Main.VCO3_D.Value = (15 - SID_Register(19)) And 15
Main.VCO3_A.Value = 15 - Int(SID_Register(19) / 16)

'Register 20: S/R VCO3
Main.VCO3_S.Value = 15 - Int(SID_Register(20) / 16)
Main.VCO3_R.Value = (15 - SID_Register(20)) And 15

'Register 21 + 22: Filter Cutoff - Frequenz
Main.Filter_Cutoff.Value = SID_Register(22) * 8 + SID_Register(21)

'Register 23: Qszillatoren und Resonanz
Main.Filter_Resonanz.Value = Int(SID_Register(23) / 16)
Main.Filter_VCO1.Value = 0: If SID_Register(23) And 1 Then Main.Filter_VCO1.Value = 1
Main.Filter_VCO2.Value = 0: If SID_Register(23) And 2 Then Main.Filter_VCO2.Value = 1
Main.Filter_VCO3.Value = 0: If SID_Register(23) And 4 Then Main.Filter_VCO3.Value = 1
Main.Filter_EXT.Value = 0: If SID_Register(23) And 8 Then Main.Filter_EXT.Value = 1

'Register 24: Lautstrke und Filterarten
Main.sVolume.Value = SID_Register(24) And 15
Main.Filter_LP.Value = 0: If SID_Register(24) And 16 Then Main.Filter_LP.Value = 1
Main.Filter_HP.Value = 0: If SID_Register(24) And 32 Then Main.Filter_HP.Value = 1
Main.Filter_BP.Value = 0: If SID_Register(24) And 64 Then Main.Filter_BP.Value = 1
Main.Filter_Off.Value = 0: If SID_Register(24) And 128 Then Main.Filter_Off.Value = 1

WriteSIDRegisters (True)
IGNORE = False
DoEvents
End Sub

Sub SEQ_ExecuteTriggers()

If SEQ_Register(AktuellerSEQStep, 32) = 1 Then TZeit1 = SEQ_Register(AktuellerSEQStep, 33): SID_Register(4) = SID_Register(4) Or 1
If SEQ_Register(AktuellerSEQStep, 34) = 1 Then TZeit2 = SEQ_Register(AktuellerSEQStep, 35): SID_Register(11) = SID_Register(11) Or 1
If SEQ_Register(AktuellerSEQStep, 36) = 1 Then TZeit3 = SEQ_Register(AktuellerSEQStep, 37): SID_Register(18) = SID_Register(18) Or 1
WriteSIDRegisters (False)

End Sub

Sub SEQ_Load(FileName As String)

Dim t As Long
Dim i As Long
Dim F As Long
Dim a As Long


F = FreeFile
Open FileName For Input As #F
For t = 0 To 15
For i = 0 To 63
Input #F, a
SEQ_Register(t, i) = a
Next i, t
Close #F

SEQ_Put

End Sub
Sub SEQ_Put()

Dim t As Long


For t = 0 To 15
Main.cTrig1(t).Value = SEQ_Register(t, 32)
Main.sTrig1(t).Value = SEQ_Register(t, 33)
Main.cTrig2(t).Value = SEQ_Register(t, 34)
Main.sTrig2(t).Value = SEQ_Register(t, 35)
Main.cTrig3(t).Value = SEQ_Register(t, 36)
Main.sTrig3(t).Value = SEQ_Register(t, 37)
Next t

Main.tMin.Text = Trim$(Str$(SEQ_Register(0, 38)))
Main.tMax.Text = Trim$(Str$(SEQ_Register(0, 39)))

End Sub



Sub SEQ_Save(FileName As String)

Dim t As Long
Dim i As Long
Dim F As Long


F = FreeFile
Open FileName For Output As #F
For t = 0 To 15
For i = 0 To 63
Print #F, Trim$(Str$(SEQ_Register(t, i)))
Next i, t
Close #F

End Sub

Sub Preset_Save(Nummer As Long)

Dim t As Long
Dim F As Long


F = FreeFile
Open PP + Trim$(Str$(Nummer)) + ".6581" For Output As #F
For t = 0 To 31
Print #F, Trim$(Str$(SID_Register(t)))
Next t
Close #F

End Sub

Sub Preset_Load(Nummer As Long)

Dim t As Long
Dim F As Long
Dim i As Byte


F = FreeFile
Open PP + Trim$(Str$(Nummer)) + ".6581" For Input As #F
For t = 0 To 31
Input #F, i
SID_Register(t) = i
Next t
Close #F

End Sub

Sub SEQ_Select(Nummer As Long)

Dim t As Long

If LetzterSEQStep = Nummer Then
   'Preset_Get
   For t = 0 To 31
   SEQ_Register(LetzterSEQStep, t) = SID_Register(t)
   Next t
End If

If LetzterSEQStep <> Nummer Then
   Main.SQQ_Led(LetzterSEQStep).FillColor = LEDOFF
   For t = 0 To 31
   SEQ_Register(LetzterSEQStep, t) = SID_Register(t)
   Next t
   'Gate-Bits lschen
   SEQ_Register(LetzterSEQStep, 4) = SEQ_Register(LetzterSEQStep, 4) And 254
   SEQ_Register(LetzterSEQStep, 11) = SEQ_Register(LetzterSEQStep, 11) And 254
   SEQ_Register(LetzterSEQStep, 18) = SEQ_Register(LetzterSEQStep, 18) And 254
   'Trigger-Einstellungen merken
   SEQ_Register(LetzterSEQStep, 32) = Main.cTrig1(LetzterSEQStep).Value
   SEQ_Register(LetzterSEQStep, 33) = Main.sTrig1(LetzterSEQStep).Value
   SEQ_Register(LetzterSEQStep, 34) = Main.cTrig2(LetzterSEQStep).Value
   SEQ_Register(LetzterSEQStep, 35) = Main.sTrig2(LetzterSEQStep).Value
   SEQ_Register(LetzterSEQStep, 36) = Main.cTrig3(LetzterSEQStep).Value
   SEQ_Register(LetzterSEQStep, 37) = Main.sTrig3(LetzterSEQStep).Value
End If


For t = 0 To 31
SID_Register(t) = SEQ_Register(Nummer, t)
Next t
Main.SQQ_Led(Nummer).FillColor = LEDON
Preset_Put
WriteSIDRegisters (False)
SEQ_ExecuteTriggers
LetzterSEQStep = Nummer

End Sub

Sub SEQ_StepBack()

AktuellerSEQStep = (AktuellerSEQStep - 1)
If AktuellerSEQStep < 0 Or AktuellerSEQStep < SEQ_Register(0, 38) Then AktuellerSEQStep = SEQ_Register(0, 39)
SEQ_Select (AktuellerSEQStep)

End Sub


Sub SEQ_StepForward()

AktuellerSEQStep = AktuellerSEQStep + 1
If AktuellerSEQStep > 15 Or AktuellerSEQStep > SEQ_Register(0, 39) Then AktuellerSEQStep = SEQ_Register(0, 38)
SEQ_Select (AktuellerSEQStep)

End Sub


Function TestePorts(Basis As Long) As String

Dim t As Long
Dim u As Byte
Dim c1 As Byte
Dim c2 As Byte
Dim ECP As Boolean
Dim Vorhanden As Boolean
Dim BI As Boolean
Dim RW As String


Debug.Print "*****  Port-Test ";
RW = ""
If Basis = LPT1_BASE Then Debug.Print "LPT1:";
If Basis = LPT2_BASE Then Debug.Print "LPT2:";
If Basis = LPT3_BASE Then Debug.Print "LPT3:";
Debug.Print " ("; Trim$(Basis); ")   *****   ";

'Testen, ob an der Adresse berhaupt ein Parallelport ist
Vorhanden = False
Call Out(Basis + 2, 0) 'Auf Ausgang setzen
Call Out(Basis, 255)
c1 = Inp(Basis)
Call Out(Basis, 0)
c2 = Inp(Basis)
'Debug.Print "255 ="; c1; ", 0 ="; c2; ", ";
If c1 = 255 And c2 = 0 Then Vorhanden = True
If Vorhanden = False Then Debug.Print " nicht vorhanden.";: GoTo Ende

'Testen, ob es ein Extended Centronics Port ist
ECP = False
Call Out(Basis + 2, 0)
c1 = Inp(Basis + &H402) And 1
'Debug.Print "Control nach $35 ="; c1
Call Out(Basis + &H402, &H34)
c2 = Inp(Basis + &H402) And 1
'Debug.Print "Control nach $34 ="; c2
If c1 = 1 And c2 = 1 Then ECP = True
Debug.Print " ECP="; ECP;
RW = RW + " ECP"

'Testen, ob es ein EPP-Port ist
BI = True
Call Out(Basis + 2, 32) 'Auf Eingang setzen (Bit 5)
Call Out(Basis, 0)
c1 = Inp(Basis)
Call Out(Basis, 255)
c2 = Inp(Basis)
'Debug.Print "255 ="; c2; ", 0 ="; c1; ", ";
If c1 = 0 And c2 = 255 Then BI = False
Debug.Print " Bidirektional="; BI;
RW = RW + " Bidirektional"


Ende: Debug.Print " "
TestePorts = RW
End Function
Sub ResetSID()

'8255 --> SID Anschlsse:
'Port A Bit 0...7  : SID Datenleitungen 0...7
'Port B Bit 0...4  : SID Adreleitungen 0...4
'Port B Bit 5 ( 32): SID -CS
'Port B Bit 6 ( 64): SID Read/-Write
'Port B Bit 7 (128): SID -Reset
'Port B Auf Ausgang setzen

Call Write_8255_SID(0, 0) 'Daten ("0") in Register A schreiben
Call Write_8255_SID(1, 32 + 64) 'Reset-Bit setzen
Sleep (100) '100 ms Reset-Impuls
Call Write_8255_SID(1, 32 + 64 + 128) 'Reset-Bit, -CS-Bit und R/W-Bit auf Standard setzen
Sleep (100)


End Sub

Sub SetzeDescherRegister()

Call Out(AKTUELLER_PORT + 2, DescherRegister)

End Sub
Function Write_8255_SID(Adresse As Long, Wert As Byte) As Long

'ParallelPort --> 8255 Anschlsse:
'Datenregister 0..7: 8255 Datenleitungen 0...7
'DescherReg. 0(  1): 8255 Adreleitung 0 (invertiert)
'DescherReg. 1(  2): 8255 Adreleitung 1 (invertiert)
'DescherReg. 2(  4): 8255 -WRITE         (invertiert)
'DescherReg. 3(  8): 8255 -CS            (normal)
'DescherReg. 4...7 : unbenutzt           (auf 0 lassen)

Dim A0 As Long
Dim A1 As Long

'Debug.Print "Der Wert"; Wert; " soll in Register #"; Adresse; "; rein !"

A0 = 1
A1 = 1
If (Adresse And 1) = 1 Then A0 = 0
If (Adresse And 2) = 2 Then A1 = 0

DescherRegister = A0 + 2 * A1 + 4 + 8 'a0+a1 setzen, WRITE+CS ausschalten
SetzeDescherRegister

'Byte ins Datenregister knppeln
Call Out(AKTUELLER_PORT, Wert)

DescherRegister = A0 + 2 * A1 + 8 'a0+a1 setzen, WRITE+CS aktivieren
SetzeDescherRegister

DescherRegister = A0 + 2 * A1 + 4 + 8 'a0+a1 setzen, WRITE+CS ausschalten
SetzeDescherRegister


End Function

Function WriteSID(Register As Byte, Wert As Byte) As Long

'8255 --> SID Anschlsse:
'Port A Bit 0...7  : SID Datenleitungen 0...7
'Port B Bit 0...4  : SID Adreleitungen 0...4
'Port B Bit 5 ( 32): SID -CS
'Port B Bit 6 ( 64): SID Read/-Write
'Port B Bit 7 (128): SID -Reset
'Port B Auf Ausgang setzen

Call Write_8255_SID(0, Wert) 'Daten in Register A schreiben
'Sleep (10)

Call Write_8255_SID(1, Register + 32 + 64 + 128) 'kein CS, Read, kein Reset
'Sleep (10)
Call Write_8255_SID(1, Register + 128) 'Register, Write, CS, kein Reset
'Sleep (10)
Call Write_8255_SID(1, Register + 32 + 64 + 128) 'Register, kein CS, Read, kein Reset
'Sleep (10)

End Function



Sub WriteSIDRegisters(Alle As Boolean)

Dim t As Byte

If Alle = True Then
   For t = 0 To 31
   Call WriteSID(t, SID_Register(t))
   SID_Register_OLD(t) = SID_Register(t)
   Next t
Else
   For t = 0 To 31
   If SID_Register_OLD(t) <> SID_Register(t) Then
      Call WriteSID(t, SID_Register(t))
      SID_Register_OLD(t) = SID_Register(t)
   End If
   Next t
End If

End Sub


